import psycopg2

class Lecteur:

    def lirePostGIS(self):
        self.connection=psycopg2.connect("dbname=infogeo_bd user=tpinfogeo host=postgresql.info.unicaen.fr password=tpinfogeo")
        requete="select astext(c.the_geom) from sn_commune as c"
        self.lirePostGIS_Requete(requete)

    def lirePostGIS_Requete(self,requete):
        self.cursor=self.connection.cursor()
        self.cursor.execute(requete)
        while 1:
            ligne = self.cursor.fetchone()
            if ligne is None: 
                break
            geographieWKT=ligne[0]
            geographie=self.lirePostGIS_WKT(geographieWKT)
        
    def lirePostGIS_WKT(self,geographieWKT):
        if geographieWKT.startswith("MULTIPOLYGON"):
            return self.lirePostGIS_WKT_Multipolygon(geographieWKT)
        if geographieWKT.startswith("MULTILINESTRING"):
            return self.lirePostGIS_WKT_Multilinestring(geographieWKT)
        if geographieWKT.startswith("POINT"):
            return self.lirePostGIS_WKT_Point(geographieWKT)
        else:
            print "Syntax WKT non supportee"

    def lirePostGIS_WKT_Multipolygon(self,geographieWKT):
        str=geographieWKT[len("MULTIPOLYGON")+3:len(geographieWKT)-3]
        geometriesSTR=str.split("),(")
        for geomSTR in geometriesSTR:
            print "Polygone passant par les points :"
            points=geomSTR.split(",")
            for point in points:
                xStr,yStr=point.split(" ")
                x,y=float(xStr),float(yStr)
                print x,y

    def lirePostGIS_WKT_Multilinestring(self,geographieWKT):
        str=geographieWKT[len("MULTILINESTRING")+2:len(geographieWKT)-2]
        geometriesSTR=str.split("),(")
        for geomSTR in geometriesSTR:
            print "Polyligne passant par les points :"
            points=geomSTR.split(",")
            for point in points:
                xStr,yStr=point.split(" ")
                x,y=float(xStr),float(yStr)
                print x,y

    def lirePostGIS_WKT_Point(self,geographieWKT):
        str=geographieWKT[len("POINT")+1:len(geographieWKT)-1]
        xStr,yStr=str.split(" ")
        x,y=float(xStr),float(yStr)
        print "Point de coordonnees ",x,y

lecteur=Lecteur()
lecteur.lirePostGIS()
